.386
.model flat,stdcall
option casemap:none

include     \masm32\include\windows.inc
include     \masm32\include\kernel32.inc
include     \masm32\include\masm32.inc
includelib  \masm32\lib\kernel32.lib
includelib  \masm32\lib\user32.lib
includelib  \masm32\lib\masm32.lib

wsprintfA PROTO C :DWORD,:VARARG
wsprintf equ <wsprintfA>

.data
template1   db '\masm32\bin\polib /machine:IX86 /def:%s.def /out:%s.lib',0
template2   db 34,'_%s@%u',34,13,10,0
template3   db 34,'%s',34,13,10,0
template4   db 'LIBRARY %s',13,10,'EXPORTS',13,10,0
template5   db 'Creating %s.lib',13,10,0
extension   dd 'fed.'
message     db 'Include file to MS COFF import library converter V1.01',13,10
            db 'usage : inc2lib incfile.inc',0
nofile      db 'File not found',0
invext      db 'Invalid file extension : ',0

.data?
wfd WIN32_FIND_DATA <?>
temp            db 256 dup(?)
cmdlineparam    db 256 dup(?)
cmdlineparam2   db 256 dup(?)
cmdlineparam3   db 256 dup(?)
buffer          dd ?
dot             dd ?
size1           dd ?
hInc            dd ?
hWfd            dd ?
eof             dd ?
fline           dd ?
dwordcount      dd ?
pcount          dd ?
flag            dd ?
hDef            dd ?
startln		dd ?
endln		dd ?

.code
start:
        invoke ArgClC,1,ADDR cmdlineparam
        mov al,byte ptr [cmdlineparam]
        or al,al
        jnz @f
        invoke StdOut,ADDR message
        jmp finish
        @@:
        invoke FindFirstFile,ADDR cmdlineparam,ADDR wfd
        mov hWfd,eax
        cmp eax,INVALID_HANDLE_VALUE
        jne OK
        invoke StdOut,ADDR nofile
        jmp finish
OK:
	invoke lstrcpy,ADDR cmdlineparam3,ADDR cmdlineparam
	invoke lstrlen,ADDR cmdlineparam3
        lea edx,[cmdlineparam3+eax-1]
@@:
        cmp BYTE PTR [edx],'\'
        jz @f
        dec edx
        dec eax
        jnz @b
@@:
        lea eax,[cmdlineparam3+eax]
	mov endln,eax
	push OFFSET cmdlineparam3
	pop startln
restart:
        mov eax,endln
	mov BYTE PTR [eax],0
	invoke lstrcpy,ADDR cmdlineparam2,ADDR wfd.cFileName
	invoke lstrcat,startln,ADDR cmdlineparam2
	invoke CreateFile,startln,GENERIC_READ,\
               0,0,OPEN_EXISTING,FILE_ATTRIBUTE_ARCHIVE,0
@@:
        mov hInc,eax
        invoke GlobalAlloc,GPTR,wfd.nFileSizeLow
        mov buffer,eax 
        invoke ReadFile,hInc,eax,wfd.nFileSizeLow,ADDR size1,0
        invoke CloseHandle,hInc
        invoke lstrlen,ADDR cmdlineparam2
        mov ecx,eax
        mov edx,OFFSET cmdlineparam2
@@:
        mov eax,DWORD PTR [edx]
        or eax,020202000h
        cmp eax,'cni.'
        je @f
        inc edx
        loop @b
        invoke StdOut,ADDR invext
        invoke StdOut,ADDR cmdlineparam2
        jmp finish
@@:
        mov dot,edx
        mov dword ptr [edx],'fed.'
        invoke CreateFile,ADDR cmdlineparam2,GENERIC_WRITE,\
                0,0,CREATE_ALWAYS,FILE_ATTRIBUTE_ARCHIVE,0
        mov hDef,eax
        mov edx,dot
        mov byte ptr [edx],0
	push esi
        push edi
       	invoke wsprintf,ADDR temp,ADDR template4,ADDR cmdlineparam2
 	mov ecx,hDef
        call write_file
        invoke wsprintf,ADDR temp,ADDR template5,ADDR cmdlineparam2
        invoke StdOut,ADDR temp
        mov esi,buffer
        mov eax,wfd.nFileSizeLow
        lea eax,[esi+eax-2]
        mov eof,eax
start0:
        mov fline,esi
        mov flag,0
        mov dwordcount,0
start1:
        cmp DWORD PTR [esi],'TORP'
        jne endline
        push esi
        push esi
        mov esi,fline
@@:
        inc esi
        mov al,BYTE PTR [esi-1]
        cmp al,32
        je @b
        cmp al,9
        je @b
        lea eax,[esi-1]
        mov fline,eax
        pop esi
@@:
        dec esi
        mov al,BYTE PTR [esi]
        cmp al,32
        je @b
        cmp al,9
        je @b
        mov BYTE PTR [esi+1],0
        pop esi
        add esi,5
        cmp BYTE PTR [esi+1],'C'
        jne fndword
        mov flag,1
fndword:

        cmp DWORD PTR [esi],'ROWD'
        jne @f
        add esi,5
        inc dwordcount
@@:
        cmp WORD PTR [esi],2573 ; CR+LF
        jz @f
        inc esi
        jmp fndword
@@:
	mov edx,flag
        or edx,edx
        jz @f
        invoke wsprintf,ADDR temp,ADDR template3,fline
	jmp wrtdef
@@:
        mov eax,dwordcount
	shl eax,2
        invoke wsprintf,ADDR temp,ADDR template2,fline,eax
wrtdef:        
	mov ecx,hDef
        call write_file
	jmp endfile     
endline:
        cmp WORD PTR [esi],2573
        jz endfile
        inc esi
        jmp start1
endfile:
        cmp esi,eof
        jz @f
        add esi,2
        jmp start0
@@:
        invoke CloseHandle,hDef
        invoke wsprintf,ADDR temp,ADDR template1,ADDR cmdlineparam2,ADDR cmdlineparam2
        invoke shell,ADDR temp
        mov esi,OFFSET extension
        mov ecx,dot
        push dword ptr [esi]
        pop dword ptr [ecx]
        invoke DeleteFile,ADDR cmdlineparam2
        pop edi
        pop esi
        invoke GlobalFree,buffer
        invoke FindNextFile,hWfd,ADDR wfd
        or eax,eax
        jz @f
        jmp restart
@@:
        invoke FindClose,hWfd
finish:
        invoke ExitProcess,0
write_file PROC
        invoke WriteFile,ecx,ADDR temp,eax,ADDR size1,0
        ret
write_file ENDP
END start
